package com.example.mock_crash

import androidx.annotation.NonNull

import io.flutter.embedding.engine.plugins.FlutterPlugin
import io.flutter.plugin.common.MethodCall
import io.flutter.plugin.common.MethodChannel
import io.flutter.plugin.common.MethodChannel.MethodCallHandler
import io.flutter.plugin.common.MethodChannel.Result
import io.flutter.plugin.common.PluginRegistry.Registrar
import java.util.*

class MyTimerTask(val str:String) : TimerTask() {
  override fun run() {
    println(str)
    System.out.println(2/0);
  }
}

/** MockCrashPlugin */
class MockCrashPlugin: FlutterPlugin, MethodCallHandler {
  /// The MethodChannel that will the communication between Flutter and native Android
  ///
  /// This local reference serves to register the plugin with the Flutter Engine and unregister it
  /// when the Flutter Engine is detached from the Activity
  private lateinit var channel : MethodChannel
//  private lateinit var aaa : MethodCall

  override fun onAttachedToEngine(@NonNull flutterPluginBinding: FlutterPlugin.FlutterPluginBinding) {
    channel = MethodChannel(flutterPluginBinding.binaryMessenger, "mock_crash")
    channel.setMethodCallHandler(this)
  }

  override fun onMethodCall(@NonNull call: MethodCall, @NonNull result: Result) {
    if (call.method == "getPlatformVersion") {
      result.success("Android ${android.os.Build.VERSION.RELEASE}")
    } else if (call.method == "crash") {
      val task = MyTimerTask("Hello World!")
      Timer().schedule(task, Date(), 1000)
      result.success(null)
    } else if (call.method == "arrayOutIndex") {
      Timer().schedule(object:TimerTask(){
        override fun run() {
          var someInts = arrayOf(1, 2, 3)
          print("第5个元素的值 ${someInts[5]}")
        }
      }, Date(), 1000)
      result.success(null)
    } else if (call.method == "throwException") {
      Timer().schedule(object:TimerTask(){
        override fun run() {
          throw RuntimeException("This is a crash");
        }
      }, Date(), 1000)
      result.success(null)
    } else {
      result.notImplemented()
    }
  }

  override fun onDetachedFromEngine(@NonNull binding: FlutterPlugin.FlutterPluginBinding) {
    channel.setMethodCallHandler(null)
  }
}