import Flutter
import UIKit

enum VendingMachineError: Error {
    case invalidSelection
    case insufficientFunds(coinsNeeded: Int)
    case outOfStock
}

public class SwiftMockCrashPlugin: NSObject, FlutterPlugin {
  public static func register(with registrar: FlutterPluginRegistrar) {
    let channel = FlutterMethodChannel(name: "mock_crash", binaryMessenger: registrar.messenger())
    let instance = SwiftMockCrashPlugin()
    registrar.addMethodCallDelegate(instance, channel: channel)
  }
    
    private func crash2() throws{
        print("in crash2")
        throw VendingMachineError.invalidSelection
    }

  public func handle(_ call: FlutterMethodCall, result: @escaping FlutterResult){
    if (call.method == "getPlatformVersion") {
      result("iOS " + UIDevice.current.systemVersion)
    } else if (call.method == "crash") {
      let someInts:[Int] = [10, 20, 30]
      print( "第5个元素的值 \(someInts[5])" )
      result(nil)
    } else if (call.method == "throwException") {
        try! crash2()
        result(nil)
    } else if (call.method == "arrayOutIndex") {
        let someInts:[Int] = [10, 20, 30]
        print( "第5个元素的值 \(someInts[5])" )
        result(nil)
    } else {
      result(nil)
    }
  }
}
